// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FMemberReference.h"
#include "ISCW_UFunction.h"
#include "ISCW_UK2Node_EditablePinBase.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_Event : public virtual ISCW_UK2Node_EditablePinBase
	{
	public:
		virtual ~ISCW_UK2Node_Event() = default;

		virtual ISCW_UFunctionPtr FindEventSignatureFunction() const = 0;

		virtual wstring GetCustomFunctionName() const = 0;

		virtual wstring GetFunctionName() const = 0;

		virtual ISCW_FMemberReferencePtr GetEventReference() const = 0;

		virtual bool GetOverrideFunction() const = 0;

		virtual void SetOverrideFunction(bool InOverride) = 0;
	};

	using ISCW_UK2Node_EventConstPtr = shared_ptr<const ISCW_UK2Node_Event>;
	using ISCW_UK2Node_EventPtr = shared_ptr<ISCW_UK2Node_Event>;
} // namespace Sourcify